<?php
/* utf8-marker = äöüß */

/*
 * avoidDC
 *
 * @author      Holger Irmler <cmsimple@holgerirmler.de>
 * @copyright   2016 Holger Irmler <http://cmsimple.holgerirmler.de/>
 *
 *
 * adc_Core_XH
 *
 * @author      Olaf Penschke   olape
 * @copyright   2020 Olaf Penschke
 * @version     1.0 b1 (14.05.2020)
 * @link        http://olaf.penschke.net/

 * @license http://www.gnu.org/licenses/gpl-3.0.en.html GNU GPLv3

============================================================================
*/
/*
 * Check if PLUGINLOADER is calling and die if not.
 */
if(!defined('PLUGINLOADER')) {
    die(
        'Plugin '. basename(dirname(__FILE__))
        . ' requires a newer version of the Pluginloader. No direct access.'
    );
}

//**************************************************************************
// dynamisches Menü unter Plugin
if(function_exists('XH_registerStandardPluginMenuItems')) {
    XH_registerStandardPluginMenuItems(true);
}
//**************************************************************************
if(XH_wantsPluginAdministration('adc_core')) {
	$o .= print_plugin_admin('on');
// Menü in der Pluginkopfzeile
    if(($admin != 'plugin_main') && ($admin != ''))
    {
        $o .= plugin_admin_common($action, $admin, $plugin);
    }
//**************************************************************************
//**************************************************************************
    $op_plugin_name = 'ADC-Core_XH';
    $op_plugin_version = '1.0 beta1';
    $op_copyright = '2020';
    $op_cms_version_arr = array('1.7.3', 'and higher');
    $op_php_version = '5.6';
//**************************************************************************
//**************************************************************************
//Anzeige nur auf Startseite des Plugins
    if(($admin == '') || ($admin == 'plugin_main'))
    {
        $o .= '<div class="xhContainer adc_core_admin">';
        /*$o .= "\n" . '<h1>' . ucfirst(str_replace('_', ' ', $plugin)) . '</h1>';*/
        $o .= '<img class="adc_core_admin_logo" alt="Logo ADC-Core_XH" src="' . $pth['folder']['plugins'] . 'adc_core/img/logo-adc_core_xh-200.png">';
        $o .= "\n" . '<h1>' . $plugin_tx['adc_core']['admin_for'] . ' CMSimple_XH</h1>
        <p>Version: ' . $op_plugin_version . '</p><p>Is based on the adc (AvoidDuplicateContent) plugin from Holger Irmler.</p>
        <p>' . $op_plugin_name . ', Copyright © ' . $op_copyright . ' <a target="_blank" href="http://olaf.penschke.net/?CMSimple_XH/Plugins">Olaf Penschke</a></p>
        <p> </p>
        <p><a target="_blank" href="http://olaf.penschke.net/?Kontakt&xh_mailform_subject=' . $op_plugin_name . '">' . $plugin_tx['adc_core']['admin_contact'] . '</a></p>
        <p> </p>
        <p><b>' . $op_plugin_name . '</b> ' . $plugin_tx['adc_core']['admin_gplv3_1'] . ' <a target="_blank" href="https://www.gnu.org/licenses/gpl-3.0.en.html">GPLv3</a> ' . $plugin_tx['adc_core']['admin_gplv3_2'] . '</p>
        <hr>
        <p>Adapted for CMSimple_XH ' . $op_cms_version_arr[0] . ' - ' . end($op_cms_version_arr) . ' by <a target="_blank" href="http://www.cmsimple-xh.org/">cmsimple-xh.org</a></p>';

//**************************************************************************
// System check
//**************************************************************************
        $o .= '<h2>System check</h2>';
// cURL
        if(function_exists('curl_init')) {
            $o .= '<p class="xh_success">'
               . ' cURL &#x2192 is installed</p>'
               . "\n";
        } else {
            $o .= '<p class="xh_fail">'
               . ' cURL &#x2192 is not installed</p>'
               . "\n";
        }
// Stream Socket Client
        if(function_exists('stream_socket_client')) {
            $o .= '<p class="xh_success">'
               . ' Stream Socket Client &#x2192 is available</p>'
               . "\n";
        } else {
            $o .= '<p class="xh_fail">'
               . ' Stream Socket Client &#x2192 is not available</p>'
               . "\n";
        }
        $o .= '<p> </p>' . "\n";
// CMSimple_XH Version
        $op_cms_version_tmp = CMSIMPLE_XH_VERSION;
        $op_cms_version_tmp = str_replace(array('CMSimple_XH '), '', $op_cms_version_tmp);
        if(in_array($op_cms_version_tmp, $op_cms_version_arr, true)) {
            $o .= '<p class="xh_success">'
               . CMSIMPLE_XH_VERSION 
               . ' &#x2192 supported</p>' 
               . "\n";
        } else {
            $o .= '<p class="xh_fail">'
               . CMSIMPLE_XH_VERSION 
               . ' &#x2192 I hope it is still supported. It was designed for ' 
               . $op_cms_version_arr[0] 
               . ' - ' 
               . end($op_cms_version_arr) 
               . '.</p>' 
               . "\n";
        }
// PHP Version
        if(version_compare(phpversion(), $op_php_version, '<')) {
            $o .= '<p class="xh_fail">PHP: ' 
               . phpversion() 
               . ' &#x2192 not supported</p>' 
               . "\n";
        } else {
            $o .= '<p class="xh_success">PHP: ' 
               . phpversion() 
               . ' &#x2192 supported</p>' 
               . "\n";
        }
        $o .= '<p> </p>' . "\n";
// Schreibrechte
        $op_filename_arr = array($pth['folder']['plugins'] . 'adc_core/css/stylesheet.css',
                                 $pth['folder']['plugins'] . 'adc_core/config/config.php',
                                 $pth['folder']['plugins'] . 'adc_core/languages/' . $sl . '.php',
                                 $pth['folder']['plugins'] . 'adc_core/css/',
                                 $pth['folder']['plugins'] . 'adc_core/config/',
                                 $pth['folder']['plugins'] . 'adc_core/languages/');
        foreach($op_filename_arr as $op_filename) {
            if(is_writable($op_filename)) {
                $o .= '<p class="xh_success">'
                   . $op_filename 
                   . ' &#x2192 writable</p>' 
                   . "\n";
            } else {
                $o .= '<p class="xh_fail">'
                   . $op_filename . ' &#x2192 not writable</p>' 
                   . "\n";
            }
        }
    $o .= '</div>';
    }
}
//**************************************************************************
//additional CSS-Class for configuration, stylesheet and language
//replaces the plugin name
if((isset($_GET['adc_core'])) && (isset($_GET['admin']))) {
    if($_GET['admin'] == 'plugin_config') {
        $o = str_ireplace('<h1>Adc_core', '<h1>' . $op_plugin_name, $o);
        $o = '<div class="xhContainer adc_core_conf">' . $o . '</div>';
    }
    if($_GET['admin'] == 'plugin_stylesheet') {
        $o = str_ireplace('<h1>Adc_core', '<h1>' . $op_plugin_name, $o);
        $o = '<div class="xhContainer adc_core_stylesheet">' . $o . '</div>';
    }
    if($_GET['admin'] == 'plugin_language') {
        $o = str_ireplace('<h1>Adc_core', '<h1>' . $op_plugin_name, $o);
        $o = '<div class="xhContainer adc_core_language">' . $o . '</div>';
    }
}
//**************************************************************************
//Return for $plugin_mcf['adc_core']['use_ssl'];
function adc_core_Check_SSL() {

    $field = 'enum:-,force_unchecked';

    $parts = parse_url(CMSIMPLE_URL);
    $host = $parts['host'];
    if (strtolower(substr($host, 0, 4)) == 'www.') {
        $host = substr_replace($host, '', 0, 4);
    }
    $host_array = array($host, 'www.'.$host);

    if (function_exists('curl_init')) {

        $field_count = 0;

        foreach ($host_array as $host_array_tmp) {
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL,'https://' . $host_array_tmp);
            curl_setopt($ch, CURLOPT_CERTINFO, 1);
            curl_setopt($ch, CURLOPT_VERBOSE, 1);
            curl_setopt($ch, CURLOPT_HEADER, 0);
            curl_setopt($ch, CURLOPT_NOBODY, 1);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,  2);
            $result = curl_exec($ch);
            if (curl_errno($ch) != 0) {
                // certificate error or failed to connect port 443
                //echo curl_errno($ch);
            } else {
                // certificate ok
                $field_count++;
            }
        }
    if ($field_count < 2) {
        $field = 'enum:-';
    } else {
        $field = 'enum:-,force';
    }
    unset($field_count);
    return $field;
    }

    if (function_exists('stream_socket_client')) {

        $field_count = 0;

        foreach ($host_array as $host_array_tmp) {
            $errno = '';
            $errstr = '';
            set_error_handler(function(){return true;}); //
            $opt = stream_context_create(array('ssl' => array('capture_peer_cert' => TRUE)));
            $fp = stream_socket_client('ssl://' . $host_array_tmp . ':443',
                  $errno, $errstr, 30, STREAM_CLIENT_CONNECT, $opt);
            restore_error_handler(); //
            if (!$fp) {
                // certificate error or failed to connect port 443
            } else {
                // certificate ok
                $field_count++;
            }
        }
    if ($field_count < 2) {
        $field = 'enum:-';
    } else {
        $field = 'enum:-,force';
    }
    unset($field_count);
    return $field;
    }

return $field;
}
?>