<?php
/* utf8-marker = äöüß */

/*
 * avoidDC
 *
 * @author      Holger Irmler <cmsimple@holgerirmler.de>
 * @copyright   2016 Holger Irmler <http://cmsimple.holgerirmler.de/>
 *
 *
 * adc_Core_XH
 *
 * @author      Olaf Penschke   olape
 * @copyright   2020 Olaf Penschke
 * @version     1.0 b1 (14.05.2020)
 * @link        http://olaf.penschke.net/

 * @license http://www.gnu.org/licenses/gpl-3.0.en.html GNU GPLv3

============================================================================
 */

//Is based on the adc plugin from Holger Irmler <cmsimple@holgerirmler.de>

include_once($pth['folder']['plugins'] . 'adc_core/config/config.php');

//force https?
$use_ssl = $plugin_cf['adc_core']['use_ssl'];
//call with or without "www"
$use_www = $plugin_cf['adc_core']['use_www'];
//corrected encoded url-seperator --> %2f, %252F
$enc_url_sep = $plugin_cf['adc_core']['corrected_enc-url-seperator'];
//remove index.php
$remove_index = $plugin_cf['adc_core']['remove_index'];

$return = XH_avoidDC($redir, $scheme, $host, $path, $query_str,
                     $use_ssl, $use_www, $enc_url_sep, $remove_index);

if(isset($return['redir'])) {$redir = $return['redir'];}
if(isset($return['scheme'])) {$scheme = $return['scheme'];}
if(isset($return['host'])) {$host = $return['host'];}
if(isset($return['path'])) {$path = $return['path'];}
if(isset($return['query_str'])) {$query_str = $return['query_str'];}

function XH_avoidDC($redir, $scheme, $host, $path, $query_str,
                    $use_ssl, $use_www, $enc_url_sep, $remove_index) {

    global $cf;

    $return = array();
    $url_sep = $cf['uri']['seperator'];

//Force Encrypted Connection
    if (($use_ssl == 'force' || $use_ssl == 'force_unchecked')
     && ($scheme == 'http')) {
        $scheme = 'https';
        $return['scheme'] = $scheme;
        $return['redir'] = true;
    }

//Replaced encoded url-seperator (i.e. / --> %2F, : --> %3A)
//sometimes also double encoded - / --> %252F --> %25252F
    if ($enc_url_sep) {
        $enus_count = 0;
        $query_str = preg_replace('#%(25)*' . bin2hex($url_sep) . '#i',
                                  $url_sep,
                                  $query_str,
                                  -1,
                                  $enus_count);
        if ($enus_count > 0) {
            $return['query_str'] = $query_str;
            $return['redir'] = true;
        }
    }

//Remove index.php
    if ($remove_index) {
        if (strtolower(substr($path, -9)) == 'index.php') {
            $path = substr_replace($path, '', -9);
            $return['path'] = $path;
            $return['redir'] = true;
        }
    }

//with or without www.
    //call page with "www"
    if ($use_www == 'force' && !isset($_GET['logout'])) {
        if (strtolower(substr($host, 0, 4)) != 'www.') {
            $host = 'www.' . $host;
            $return['host'] = $host;
            $return['redir'] = true;
            //if changed
            adc_core_logout();
        }
    }
    //or filter out "www" if required
    if ($use_www == 'none' && !isset($_GET['logout'])) {
        if (strtolower(substr($host, 0, 4)) == 'www.') {
            $host = substr_replace($host, '', 0, 4);
            $return['host'] = $host;
            $return['redir'] = true;
            //if changed
            adc_core_logout();
        }
    }

return $return;
}

//logout if changed with or without www.
function adc_core_logout() {

    $url = CMSIMPLE_URL . '?&logout';

    if (XH_ADM) {
        if (isset($_GET['admin']) && $_GET['admin'] == 'plugin_config') {
            if (isset($_GET['xh_success']) && $_GET['xh_success'] == 'config') {
                header("Location: $url");
                exit;
            }
        }
    }
}
